#include "Form1.h"

using namespace Osp::Base;
using namespace Osp::Ui;
using namespace Osp::Ui::Controls;

Form1::Form1(void)
{
}

Form1::~Form1(void)
{
}

bool
Form1::Initialize()
{
	// Construct an XML form
	Construct(L"IDF_FORM1");

	return true;
}

result
Form1::OnInitializing(void)
{
	result r = E_SUCCESS;

	// TODO: Add your initialization code here

	// Get a button via resource ID
	__pButtonOk = static_cast<Button *>(GetControl(L"IDC_BUTTON_OK"));
	if (__pButtonOk != null)
	{
		__pButtonOk->SetActionId(ID_BUTTON_OK);
		__pButtonOk->AddActionEventListener(*this);
	}

	__pFooter = GetFooter();
	__pFooter->AddActionEventListener(*this);
	__pFooter->SetBackButton();

	__pFooterItem3 = new FooterItem();
	__pFooterItem3->Construct(102);
	__pFooterItem3->SetText(L"Button 3");
	__pFooter->AddItem(*__pFooterItem3);

	SetFormBackEventListener(this);

	return r;
}

result
Form1::OnTerminating(void)
{
	result r = E_SUCCESS;

	// TODO: Add your termination code here

	return r;
}

void
Form1::OnActionPerformed(const Osp::Ui::Control& source, int actionId)
{
	switch(actionId)
	{
		case ID_BUTTON_OK:
		{
			AppLog("Button is clicked!");
		}
		break;
		case 100:
			{
				AppLog("Footer Button 1 is clicked!");
			}
			break;
		case 101:
			{
				AppLog("Footer Button 2 is clicked!");
			}
			break;
		case 102:
			{
				AppLog("Footer Button 3 is clicked!");
			}
			break;
		default:
			break;
	}
}

// IFormBackEventListener
void Form1::OnFormBackRequested(Osp::Ui::Controls::Form &source)
{
	AppLog("Back button pressed.");
}
